"""Confighandler.py
Part of Mercury reader"""

# Copyright (C) 2003  Marek Kubica <gradamani AT surfeu DOT de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from xml.sax.handler import ContentHandler
from user import User

class ConfigHandler(ContentHandler):
	server = ""
	port = ""
	channel = ""
	reconnect = ""
	nickname = ""
	realname = ""
	LogFlags = None
	
	#Core properties
	inServer = False
	inPort = False
	inChannel = False
	inReconnect = False
	inNickname = False
	inRealname = False
	inLog = False
	
	#users
	inUser = False
	UserFlags = ""
	UserGreet = ""
	
	#channels <- s is important else errors
	inMaxUsers = False
	max_users = ""
	inJoinMsg = False
	join_msg = ""
	
	BotRoot = ""
	UserList = []
	
	def startElement(self, name, attrs):
		if name == "server":
			#print "server found, setting..."
			self.inServer = True
		if name == "port":
			self.inPort = True
		if name == "channel":
			self.inChannel = True
		if name == "reconnect":
			self.inReconnect = True
		if name == "nickname":
			self.inNickname = True
		if name == "realname":
			self.inRealname = True
		if name == "log":
			if attrs.get("enabled", "") == "True":
				self.inLog = True
			elif attrs.get("enabled", "") == "False":
				self.Log = None
				self.inLog = False
		if name == "user":
			self.inUser = True
			self.UserFlags = attrs.get("flags", "")
			self.UserGreet = attrs.get("greet", "")
			if self.UserGreet == "":
				self.UserGreet = "nogreet"
		if name == "max_users":
			if attrs.get("enabled", "") == "True":
				self.inMaxUsers = True
			elif attrs.get("enabled", "") == "False":
				self.inMaxUsers = False
				self.max_users = None
		if name == "join_msg":
			# Why is this always True???!!!
			if attrs.get("enabled", "") == "True":
				self.inJoinMsg = True
			elif attrs.get("enabled", "") == "False":
				self.inJoinMsg = False
				self.join_msg = None

		#print "Element name: ", name
		#print "Attrs: ", attrs

		
	def characters(self, characters):
		if self.inServer:
			self.server = characters
			#print "Server: ", self.server
			self.inServer = False
		if self.inPort:
			self.port = int(characters)
			#print "Port: ", self.port
			self.inPort = False
		if self.inChannel:
			self.channel = characters
			#print "Channel: ", self.channel
			self.inChannel = False
		if self.inReconnect:
			self.reconnect = characters
			#print "Reconnect: ", self.reconnect
			self.inReconnect = False
		if self.inNickname:
			self.nickname = characters
			#print "Nickname: ", self.nickname
			self.inNickname = False
		if self.inRealname:
			self.realname = characters
			#print "Realname: ", self.realname
			self.inRealname = False
		if self.inLog:
			self.LogFlags = characters
			self.inLog = False
		if self.inUser:
			"""Now this code is modified to work with Ozone"""
			#print "User: ", characters
			#print "Flags: ", self.UserFlags
			#print "Greet: ", self.UserGreet
			if self.UserFlags.count("B") == 1:
				self.BotRoot = User(characters, self.UserFlags)
				#print "BotRoot ",self.BotRoot
			else:
				usr = User(characters, self.UserFlags)
				if self.UserFlags.count("g") == 1:
					usr.setGreet(self.UserGreet)
				self.UserList.append(usr)
				
			self.inUser = False
		if self.inMaxUsers:
			self.max_users = int(characters)
			self.inMaxUsers = False
		if self.inJoinMsg:
			self.join_msg = characters
			self.inJoinMsg = False