#!/usr/bin/env python

# configure - makes an ePyCycle XML configfile
# Copyright (C) 2003  Marek Kubica <gradamani AT surfeu DOT de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from sys import exit

print """Welcome to ePyCycle. This script helps you to write the configfile.
Backup your old epycycle.xml if you want to save it.
"""

print """Okay, let's go!
What IRC server do you want to connect to?
You can also enter the IP, but why?"""
server = raw_input("[lunix.homelinux.org] ")
if server == "":
	server = "lunix.homelinux.org"
	
print """
What port does your server use?"""
port = raw_input("[6667] ")
if port == "":
	port = "6667"

print """
What reconnect interval (in seconds) should the bot use?
This setting tells the bot how long it should wait
after getting a restart command"""
reconnect = raw_input("[10] ")
if reconnect == "":
	reconnect = "10"
	
print """
Good, now something more interessting.

What nickname should the bot have?
Now you must use your brain and find a cool nickname.
Remember, the nick must not contain spaces and
on some servers it must be very short"""
nick = raw_input("[] ")
if nick == "":
	no_nick_set = True
	prompt = "->"
	while no_nick_set:
		prompt = "-" + prompt
		print "Hey, the bot needs a nick!"
		nick = raw_input(prompt)
		if nick != "":
			no_nick_set = False
			print "Well done ;)"
			
print """
Oh, well. This setting is very interesting, it sets
up what the bot will log into his logfile
Possible flags are:
s - starts and stops
w - warnings
c - commands
d - debug (don't use it untill you have to,
it makes the configfile look weird)
Of course the flags can be combined"""
log = raw_input("[s] ")
if log == "":
	log = "s"

print """
Now we've got to configure the bot's Realname,
so I think we can set in to ePyCycle, can't we?
Of course you can set something other"""
realname = raw_input("[ePyCycle] ")
if realname == "":
	realname = "ePyCycle"
	
print """
What channel should the bot serve?
This is the channel, where the bot joins and waits.
The channel's name has in it's beginning a '#'"""
channel = raw_input("[#whg] ")
if channel == "":
	channel = "#whg"

print """
We're quite on the end, but we still must  configure the BotRoot.
The BotRoot ist the guy who has all the power with the bot. 
He's able to run every command on the bot.
Remember: The account is not password-protected!
The person with the BotRoot's nick is the BotRoot,
so pay attention."""
botroot = raw_input("[] ")
if botroot == "":
	no_root_set = True
	prompt = "->"
	while no_root_set:
		prompt = "-" + prompt
		print "Hey, forgotten the BotRoot?"
		nick = raw_input(prompt)
		if nick != "":
			no_root_set = False
			print "Well done ;)"
			
print """
I'll display the settings, so you can say if they are correct
If you say no, the program will exit, so you can start again."""
print "Server:", server
print "Port:", port
print "Reconnect:", reconnect
print "Channel:", channel
print "Nickname:", nick
print "Realname:", realname
print "BotRoot:", botroot

correct = raw_input("Are these settings correct? [y] ")
if correct == "":
	correct = "y"

correct = correct.lower()
if correct == "y":
	pass
elif correct == "n":
	print "You say no, I'll let you go! (nice, isn't it ;)"
	exit(100)
else:
	bad_answer = True
	prompt = "->"
	while bad_answer:
		prompt = "-" + prompt
		print "you must answer with Y or N"
		correct = raw_input(prompt)
		correct = correct.lower()
		if correct == "y":
			bad_answer = False
		elif correct == "n":
			print "You say no, I'll let you go! (nice, isn't it ;)"
			exit(100)

#User confirmed
print "Writing configfile",
config = file("epycycle.xml", "w")
#Now the progress with print"
print ".",

config.write('<?xml version="1.0"?>\n')
print ".",

config.write('<epycycle>\n')
config.write('\t<core>\n')
config.write('\t\t<server>' + server + '</server>\n')
print ".",

config.write('\t\t<port>' + port + '</port>\n')
print ".",

config.write('\t\t<channel>' + channel + '</channel>\n')
print ".",

config.write('\t\t<reconnect>' + reconnect + '</reconnect>\n')
print ".",

config.write('\t\t<nickname>' + nick + '</nickname>\n')
print ".",

config.write('\t\t<realname>' + realname + '</realname>\n')
config.write('\t\t<log enabled="True">' + log + '</log>\n')
config.write('\t</core>\n')
config.write('\t<users>\n')
print ".",

config.write('\t\t<user flags="B">' + botroot + '</user>\n')
config.write('\t</users>\n')
print ".",

config.write('\t<channels>\n')
config.write('\t\t<max_users>1</max_users>\n')
config.write('\t</channels>\n')

config.write('</epycycle>\n')
config.close()
print " Done"