#! /usr/bin/env pythong
# ePycycle bot (Codename Storm)

# Copyright (C) 2003  Marek Kubica <gradamani AT surfeu DOT de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import string
from ircbot import SingleServerIRCBot
from readconfig import Settings
from user import User
import logger

st = Settings()
BotRoot = st.BotRoot
logger.LogFlags = st.LogFlags

UserList = []
max_users = st.max_users
join_msg = st.join_msg
del(st)

"""Channel Flags
g - greet
a - action
s - say
h - help
D - Die
R - Restart
c - channel stuff (users(on, off) greet(activate, deactivate, change))
G - greets (on, off,change)
U - user control

"""
all_flags = "gashDRcGU"

class ePyCycle(SingleServerIRCBot):
	def __init__(self, server, port, nickname, channel, realname, recon):
		SingleServerIRCBot.__init__(self, [(server, port)], nickname, realname, recon)
		self.channel = channel
		logger.write("Spawning bot", "s")
		self.start()

	def on_welcome(self, connection, event):
		connection.join(self.channel)
		logger.write("on_welcome(): joining channel " + self.channel + ": successful", "d")
		
	def on_join(self, connection, event):
		"""Source is the user,
		target is the channel"""
		simpleuser = string.split(event.source(), "!", 1)
		
		#max_channel user feature
		st = Settings()
		if simpleuser[0] != st.nickname:
			# That must be str, else in don't works
			ascii_channel = str(self.channel)
			users_in_channel = self.channels[ascii_channel].users()
			users_in_channel.append(simpleuser[0])
			# Must be, else there are problems with the interpreter
			global max_users
			if max_users != None:
				if len(users_in_channel) > max_users:
					max_users = max_users + 1
					save()
					connection.notice(st.channel, "New user record: " + str(max_users)+ "!")

		if simpleuser[0] != st.nickname:
			if st.join_msg != None:
				connection.notice(simpleuser[0], join_msg)
		
		lists = access()
		lists.load()
		
		
		if is_in_list(simpleuser[0]) != False:
			# User is in a list
			index = getIndexOfUser(simpleuser[0])
			flags = UserList[index].getFlags()
			
			if flags.count("g") == 1:
				connection.privmsg(event.target(), UserList[index].getGreet())
		
	def on_privmsg(self, connection, event):
		"""on_privmsg - if a privmsg arrives the bot
		uses the Ozone concept"""
		
		# simpleuser[0] is the nick
		simpleuser = string.split(event.source(), "!", 1)
		#print simpleuser[0]
		
		if is_in_list(simpleuser[0]) == True:
			#print event.arguments()[0]
			
			# Where in the list is the user?
			userindex = getIndexOfUser(simpleuser[0])
			userflags = UserList[userindex].getFlags()
			
			if event.arguments()[0][:3] == "say":
				if userflags.count("s") == 1:
					logger.write(simpleuser[0] + " executed say command: sucessful", "c")
					self.say(event.arguments()[0][4:], connection)
				else:
					logger.write(simpleuser[0] + " executed say command: permission denied", "c")
					connection.notice(simpleuser[0], "Permission denied")
					
			if event.arguments()[0][:6] == "action":
				if userflags.count("a") == 1:
					logger.write(simpleuser[0] + " executed action command: sucessful", "c")
					self.action(event.arguments()[0][7:], connection)
				else:
					logger.write(simpleuser[0] + " executed action command: permission denied", "c")
					connection.notice(simpleuser[0], "Permission denied")
					
			if event.arguments()[0][:4] == "help":
				if userflags.count("h") == 1:
					self.help(event.arguments()[0][5:], simpleuser[0], connection)
				else:
					connection.notice(simpleuser[0], "Permission denied")
					
			if event.arguments()[0][:3] == "die":
				if userflags.count("D") == 1:
					logger.write(simpleuser[0] + " executed die command: sucessful", "c")
					logger.write("Going down on user request", "s")
					# This goes down real fast, so no need to make another 'def'
					self.die()
			elif event.arguments()[0][:7] == "restart":
				if userflags.count("R") == 1:
					# This is also very fast
					self.disconnect()
			elif event.arguments()[0][:9] == "listusers":
				if userflags.count("U") == 1:
					self.list_users(simpleuser[0], connection)
			elif event.arguments()[0][:3] == "add":
				if userflags.count("U") == 1:
					user_and_flags = event.arguments()[0][4:]
					user_and_flags = string.split(user_and_flags, " ", 1)
					acc = access()
					acc.add(user_and_flags[0], user_and_flags[1])
			elif event.arguments()[0][:6] == "remove":
				if userflags.count("U") == 1:
					whatuser = event.arguments()[0][7:]
					acc = access()
					success = acc.remove(whatuser)
					if success != True:
						connection.notice(simpleuser[0], "Something went wrong: Maybe no such user?!")
	
	def say(self, text, connection):
		"""Say - says something in the bots channel"""
		st = Settings()
		connection.privmsg(st.channel, text)
	def action(self, action, connection):
		"""Makes a /me action in the channel"""
		st = Settings()
		# Sends a CTCP (?) action to the channel
		# Thx to the ethereal team for the good work!
		connection.action(st.channel, action)
		
	def help(self, what, user, connection):
		"""New, easier help system"""
		if what == "":
			connection.notice(user, "Topics:")
			connection.notice(user, "flags - displays information about flags")
			connection.notice(user, "botroot - the botroot's exclusive commands")
			connection.notice(user, "say - says sth into the channel")
			connection.notice(user, "action - performs a czhannel action")
			connection.notice(user, "version - displays the bots version")
		elif what == "flags":
			userindex = getIndexOfUser(user)
			userflags = UserList[userindex].getFlags()
			flags = "Your flags are: " + userflags
			
			connection.notice(user, flags)
			connection.notice(user, "Possible flags are:")
			connection.notice(user, "h - access the help")
			connection.notice(user, "g - have a 'OnJoin' Greet")
			connection.notice(user, "s - access to the say command")
			connection.notice(user, "a - acess to the action command")
			connection.notice(user, "B - be BotRoot (can only be one person)")
		elif what == "version":
			connection.notice(user, "ePyCycle Bot by Marek Kubica <gradamani AT surfeu DOT DE>")
		elif what == "botroot":
			connection.notice(user, "These commands are only useful if you are BotRoot")
			connection.notice(user, "add - adds a user")
			connection.notice(user, "remove - removes a user from the list")
			connection.notice(user, "restart - restarts the bot")
			connection.notice(user, "die - kills the bot")

	def list_users(self, user, connection):
		lists = access()
		lists.list(user, connection)
		
	def brcmd(self, user, command, connection):
		"""BotRoot Command - Executes BotRoot's Commands
		"""
		lists = access()
		if command == "save":
			connection.notice(user, "This is internal and shouldn't be used")
			lists.save()
		elif command == "load":
			connection.notice(user, "This is internal and shouldn't be used")
			lists.load()
		elif command[:4] == "help":
			if command == "help":
				connection.notice(user, "status - gets user's group")
			if command[5:] == "add":
				connection.notice(user, "Syntax: add <User> <Group> <Greet>")
				connection.notice(user, "Greet is mandatory, if you wish no greet type nogreet for greet")
			if command[5:] == "remove":
				connection.notice(user, "syntax: remove <User>")
			if command[5:] == "list":
				connection.notice(user, "syntax: list")
				connection.notice(user, "Lists all users which are listed in the bot")
			if command[5:] == "status":
				connection.notice(user, "syntax: status <User>")
				connection.notice(user, "Get's users' status (Normal/General/Op/Admin")
			if command[5:] == "restart":
				connection.notice(user, "syntax: restart")
				connection.notice(user, "Disconnects the bot, waits some time and reconnects the bot")
			if command[5:] == "die":
				connection.notice(user, "syntax: die")
				connection.notice(user, "Shuts the bot down")
				
class access:
	def __init__(self):
		#Load Users
		self.load()
	def add(self, user, flags):
		"""adds Ozone users to list"""
		usr = User(user, flags)
		UserList.append(usr)
		save()
			
	def setGreet(self, user, greet):
		if is_in_list != True:
			return False
		else:
			userindex = getIndexOfUser(user)
			UserList[userindex].setGreet(greet)
			return True
	def remove(self, user):
		"""Uses Mercury and Ozone"""
		
		# Search user in the lists
		if is_in_list(user) == False:
			return False
		else:
			# Where to find the user in the list
			index = getIndexOfUser(user)
			# Remove the user from the list
			UserList.pop(index)
			# Save userlist
			save()
			# Load new userlist (maybe not needed)
			self.load()
			return True
			
	def list(self, user, connection):
		"""Lists Ozone users"""
		for eachUser in UserList:
			sendnick = eachUser.getNickname() + "+"
			sendnick = sendnick + eachUser.getFlags() + "+"
			sendnick = sendnick + eachUser.getGreet()
			connection.notice(user, sendnick)
	def load(self):
		"""Load uses already the mercury component"""
		#print "List before del_lists:", UserList
		self.del_lists()
		st = Settings()
		st.refresh()
		
		# UserList has to be empty!!!
		for eachUser in st.UserList:
			UserList.append(eachUser)
			
		# Load Botroot
		BotRoot = st.BotRoot
		# Create simple user BotRoot, with all flags
		br = User(BotRoot.Nickname, all_flags)
		# Append the new BotRoot to the userlist
		UserList.append(br)
		


	def del_lists(self):
		"""Delete entire UserList
		It was a hard work to get it do what it should do"""
		#Modified to work with Mercury concept
		
		lu = len(UserList)
		#print "Len of UserList:",
		#print lu
		
		if lu != 0:
			lu_not_zero = 1
			while lu_not_zero:
				lu = lu - 1
				#print "Now lu:",
				#print lu
				UserList.pop(lu)
				#print "Now UserList:",
				#print UserList
				#lu = lu - 1
				if lu == 0:
					lu_not_zero = 0
		
def save():

	from writeconfig import ConfigWriter
	
	st = Settings()
	cw = ConfigWriter()
		
	cw.server = st.server
	cw.port = st.port
	cw.channel = st.channel
	cw.reconnect = st.reconnect
	cw.nickname = st.nickname
	cw.realname = st.realname
	cw.BotRoot = st.BotRoot
	cw.max_users = max_users
	cw.join_msg = join_msg
	cw.logflags = LogFlags
		
	cw.del_lists()
	
	for eachUser in UserList:
		cw.UserList.append(eachUser)
	cw.write()

def main():
	options = loadxmlsettings()
	logger.write("main(): Connection settings", "d")
	logger.write("main(): server: " +  options[0] + ":" + str(options[1]), "d")
	logger.write("main(): nickname: " + options[2] + " realname: " + options[4], "d")
	logger.write("main(): channel: " + options[3] + " reconnect: " + str(options[5]), "d")
	#print "Server: " + options[0]
	#print "Port: " + str(options[1])
	#print "Nickname: " + options[2]
	#print "Realname: " + options[4]
	#print "Channel: " + options[3]
	#print "Reconnect: " + str(options[5]) + "sec" 
	
	bot = ePyCycle(options[0], options[1], options[2], options[3], options[4], options[5])
	bot.start()

	
def loadxmlsettings():
	#Create Settings object with all xml data
	st = Settings()
	
	#Get data from object
	set_server = st.server
	set_port = st.port
	set_nickname = st.nickname
	set_realname = st.realname
	set_channel = st.channel
	set_recon = st.reconnect

	#Convert strings to ints
	set_port = int(set_port)
	set_recon = int(set_recon)
	
	
	# make a list
	set_all = [set_server, set_port, set_nickname, set_channel, set_realname, set_recon]
	#print set_all
	
	return set_all
	
def is_in_list(user):
	for eachUser in UserList:
		#print "eU", eachUser.getNickname()
		#print "user", user
		if eachUser.getNickname() == user:
			#print "User found"
			return True
	return False
				
	#print "No user found"
	return 1
		
def getIndexOfUser(user):
	index = 0
	for eachUser in UserList:
		if eachUser.getNickname() == user:
			return index
		else:
			index = index + 1
	return None
	
if __name__ == "__main__": main()