"""ePyCycle phosphor component
Provides logging abilities to epycycle"""
# Copyright (C) 2003  Marek Kubica <gradamani AT surfeu DOT de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import time

logfile = "epycycle.log"
"""LogFlags:
s - Log starts and stops
w - Log warnings
c - Log commands
d - Log debug"""
LogFlags = "swcd"

def write(text, type):
	log = file(logfile, "a")
	
	# Create a formatted time string
	time_format = time.localtime()
	year = str(time_format[0])
	if time_format[1] < 10:
		month = "0" + str(time_format[1])
	else:
		month = str(time_format[1])
	if time_format[2] < 10:
		day = "0" + str(time_format[2])
	else:
		day = str(time_format[2])
	if time_format[3] < 10:
		hour = "0" + str(time_format[3])
	else:
		hour = str(time_format[3])
	if time_format[4] < 10:
		minute = "0" + str(time_format[4])
	else:
		minute = str(time_format[4])
	if time_format[5] < 10:
		second = "0" + str(time_format[5])
	else:
		second = str(time_format[5])
		
	time_now = year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + second
	
	if LogFlags.count(type) == 1:
		log.write(time_now + " " + text + "\n")
		
	log.close()

def remove():
	"""To remove the complete configfile"""
	from os import remove
	remove(logfile)
	
def truncate():
	"""To tuncate the older parts of the configfile
	by lines (to truncate, to survive), by size and maybe time"""
	pass
	