#!/usr/bin/env python
""" readconfig.py
Mercury read component"""

# Copyright (C) 2003  Marek Kubica <gradamani AT surfeu DOT de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys
from xml.sax import make_parser
from confighandler import ConfigHandler

ch = ConfigHandler( )
saxparser = make_parser( )

saxparser.setContentHandler(ch)
saxparser.parse("epycycle.xml")

class Settings:
	server = ch.server
	port = ch.port
	channel = ch.channel
	reconnect = ch.reconnect
	nickname = ch.nickname
	realname = ch.realname
	LogFlags = ch.LogFlags

	BotRoot =  ch.BotRoot
	UserList = ch.UserList
	
	max_users = ch.max_users
	join_msg = ch.join_msg
	
	def del_lists(self):
		"""Deletes the list - copied from storm component"""
		lu = len(self.UserList)
		
		if lu != 0:
			lu_not_zero = 1
			while lu_not_zero:
				lu = lu - 1
				self.UserList.pop(lu)
				if lu == 0:
					lu_not_zero = 0
	
	def refresh(self):
		# Delete lists...
		self.del_lists()
		# ... and parse again!
		saxparser.parse("epycycle.xml")
		

