#!/usr/bin/env python
""" Mercury write component"""

# Copyright (C) 2003  Marek Kubica <gradamani AT surfeu DOT de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

class ConfigWriter:
	outFile = "epycycle.xml"
	
	#Properties
	server = ""
	port = 0
	reconnect = 0
	channel = ""
	nickname = ""
	realname = ""
	
	max_channels = 0
	logflags = None
	
	BotRoot = ""
	UserList = []
	
	def write(self):
		self.configfile = file(self.outFile, "w")
		self.writeHeader()
		self.writeCore()
		self.writeUsers()
		self.writeChannels()
		self.configfile.close()
	def writeHeader(self):
		self.configfile.write('<?xml version="1.0"?>\n')
		self.configfile.write('<epycycle>\n')
		self.configfile.write('\t<core>\n')
	def writeCore(self):
		self.configfile.write('\t\t<server>' + self.server + '</server>\n')
		self.port = str(self.port)
		self.configfile.write('\t\t<port>' + self.port + '</port>\n')
		self.configfile.write('\t\t<channel>' + self.channel + '</channel>\n')
		self.reconnect = str(self.reconnect)
		self.configfile.write('\t\t<reconnect>' + self.reconnect + '</reconnect>\n')
		self.configfile.write('\t\t<nickname>' + self.nickname + '</nickname>\n')
		self.configfile.write('\t\t<realname>' + self.realname + '</realname>\n')
		if logflags != None:
			self.configfile.write('\t\t<log enabled="True">' + self.logflags + '</log>\n')
		else:
			self.configfile.write('\t\t<log enabled="False"></log>')
		self.configfile.write('\t</core>\n')
		self.configfile.write('\t<users>\n')
	def writeUsers(self):
		self.configfile.write('\t\t<user flags="B">' + self.BotRoot.getNickname() + '</user>\n')
		for eachUser in self.UserList:
			self.configfile.write('\t\t<user flags="' + eachUser.getFlags() + '" greet="' + eachUser.getGreet() + '">' + eachUser.getNickname() + '</user>\n')
		self.configfile.write('\t</users>\n')
	def writeChannels(self):
		self.configfile.write('\t<channels>\n')
		if self.max_users != None:
			self.configfile.write('\t\t<max_users enabled="True">' + str(self.max_users) + '</max_users>\n')
		else:
			self.configfile.write('\t\t<max_users enabled="False">' + 1 + '</max_users>\n')
		if self.join_msg != None:
			self.configfile.write('\t\t<join_msg enabled="True">' + self.join_msg + '</join_msg>\n')
		else:
			self.configfile.write('\t\t<join_msg enabled="False">Nothing to say</join_msg>\n')
		self.configfile.write('\t</channels>\n')
		self.configfile.write('</epycycle>')
	
	def del_lists(self):
		"""Deletes the list - copied from storm component"""
		lu = len(self.UserList)
		
		if lu != 0:
			lu_not_zero = 1
			while lu_not_zero:
				lu = lu - 1
				self.UserList.pop(lu)
				if lu == 0:
					lu_not_zero = 0

if __name__ == "__main__":
	cf = ConfigWriter()
	cf.write()